/*********************************************************************
* MCB.C - Functions for handling DOS's MCB chain.                    *
*********************************************************************/
#include <dos.h>     /* intdosx(), REGS, SREGS                      */
#include "mcb.h"     /* getFirstMCB(), getNextMCB(), MCB, MK_FP     */

/*********************************************************************
* getFirstMCB - Gets the address of the first MCB in the chain.      *
*********************************************************************/
MCB far *getFirstMCB( void )
    {
    int i;                     /* Temporary scratch variable        */
    int far *p;                /* Temporary pointer variable        */

    regs.h.ah = 0x52;          /* Undocumented DOS call             */
    intdosx( &regs, &regs, &sregs );
    i = sregs.es;
    p = MK_FP( i, regs.x.bx-2 );  /* Compute address of 1st MCB seg */
    return MK_FP( *p, 0 );
    }

/*********************************************************************
* getNextMCB - Given a pointer to an MCB in the chain, returns the   *
*   address of the next MCB in the chain.                            *
*********************************************************************/
MCB far *getNextMCB( MCB far *x )
    {
    return MK_FP( GET_SEG(x) + x->size + 1, 0 );
    }

